# Contributing

## About HierarchicalKV

HierarchicalKV is a part of NVIDIA Merlin and provides hierarchical key-value storage to meet RecSys requirements.

The key capability of HierarchicalKV is to store key-value (feature-embedding) on high-bandwidth memory (HBM) of GPUs and in host memory.

You can also use the library for generic key-value storage.

## Maintainership

HierarchicalKV is co-maintianed by [NVIDIA Merlin Team](https://github.com/NVIDIA-Merlin) and NVIDIA product end-users,
and also open for public contributions, bug fixes, and documentation. This project adheres to NVIDIA's Code of Conduct.

## Contributing

We’re grateful for your interest in HierarchicalKV and value your contributions. 
We welcome contributions via pull requests(PR). 

Before sending out a pull request for significant change on the end-user API, we recommend you open an issue and
discuss your proposed change. Some changes may require a design review.
All submissions require review by project reviewers.

### Coding Style

Refer to the [Style Guide](http://github.com/NVIDIA-Merlin/HierarchicalKV/STYLE_GUIDE.md)

### Additional Requirements

In addition to the above requirements, contribution also needs to meet the following criteria:
* The change needs to include unit tests and integration tests if any.
* Each PR needs to provide necessary documentation for when and how to use it.

## Community

* HierarchicalKV code (https://github.com/NVIDIA-Merlin/HierarchicalKV)

## Licence
Apache License 2.0

